#ifndef GROUP_FILE_H
#define GROUP_FILE_H

#include <stdio.h>
#include "group.h"

int fill_group_from_file(
	group_t * pgroup,           // input
	group_spec_t * pspec,       // input
	void    * pvaux,            // input
	char    * elements_file,    // input
	void    * elements_buffer,  // output
	int       max_group_bytes); // output

int fill_group_from_stream(
	group_t * pgroup,           // input
	group_spec_t * pspec,       // input
	void    * pvaux,            // input
	FILE    * elements_fp,      // input
	void    * elements_buffer,  // output
	int       max_group_bytes); // output

#endif // GROUP_FILE_H
