#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "group.h"
#include "group_inverse.h"

// ----------------------------------------------------------------
void show_inverse(
	group_t * pgroup)
{
	void * pa;
	unsigned char ainverse[VOP_MAX_ELEMENT_SIZE];
	int i, j;

	// xxx temp
	int power = pgroup->num_elements - 1;
	// xxx raise to |G|-1, but use log2(n) algm.
	// xxx use a element_power() function.

	// xxx to lib func.
	if (pgroup->pspec->element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: group element size %d too big.\n",
				__FILE__, pgroup->pspec->element_size);
		exit(1);
	}

	for (i = 0; i < pgroup->num_elements; i++) {
		pa = VGROUP_ELEMENT(pgroup, i);
		memcpy(ainverse, pa, pgroup->pspec->element_size);
		for (j = 1; j < power; j++) {
			pgroup->pspec->pvop(ainverse, ainverse, pa,
				pgroup->pvaux);
		}
		pgroup->pspec->pvprint(pa, pgroup->pvaux);
		printf("  ");
		pgroup->pspec->pvprint(ainverse, pgroup->pvaux);
		printf("\n");
	}
}
