#ifndef RING_COSETS_H
#define RING_COSETS_H
#include "ring.h"

#define LEFT_COSETS  1
#define RIGHT_COSETS 0

int make_cosets(
	ring_t  * pG,
	ring_t  * pH,
	int        direction,
	ring_cosets_t * pcosets,
	void     * quot_elements_buffer,
	int        max_cosets_bytes,
	int        verbosity);

#endif // RING_COSETS_H
