#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ring.h"
#include "ring_inverse.h"

// ----------------------------------------------------------------
void show_inverse(
	ring_t * pring)
{
	void * pa;
	unsigned char ainverse[VOP_MAX_ELEMENT_SIZE];
	int i, j;

	// xxx temp
	int power = pring->num_elements - 1;
	// xxx raise to |G|-1, but use log2(n) algm.
	// xxx use a element_power() function.

	// xxx to lib func.
	if (pring->pspec->element_size > VOP_MAX_ELEMENT_SIZE) {
		fprintf(stderr,
			"%s: ring element size %d too big.\n",
				__FILE__, pring->pspec->element_size);
		exit(1);
	}

	for (i = 0; i < pring->num_elements; i++) {
		pa = VRING_ELEMENT(pring, i);
		memcpy(ainverse, pa, pring->pspec->element_size);
		for (j = 1; j < power; j++) {
			pring->pspec->pvop(ainverse, ainverse, pa,
				pring->pvaux);
		}
		pring->pspec->pvprint(pa, pring->pvaux);
		printf("  ");
		pring->pspec->pvprint(ainverse, pring->pvaux);
		printf("\n");
	}
}
