#ifndef MIQUAT_H
#define MIQUAT_H

#include "group.h"

typedef struct _miquat_t {
	int H;
	int I;
	int J;
	int K;
} miquat_t;

miquat_t miquat_add(miquat_t a, miquat_t b, int m);
miquat_t miquat_sub(miquat_t a, miquat_t b, int m);
miquat_t miquat_mul(miquat_t a, miquat_t b, int m);
int      miquat_equal(miquat_t a, miquat_t b, int m);

extern group_spec_t miquat_add_group_spec;
extern group_spec_t miquat_mul_group_spec;

extern group_spec_t smiquat_add_group_spec;
extern group_spec_t smiquat_mul_group_spec;

#endif // MIQUAT_H
