// Elements of the ring Q[x] / (r(x)) (a field when r(x) is irreducible).

#ifndef QPOLYMOD_H
#define QPOLYMOD_H

#include "qpoly.h"

// ----------------------------------------------------------------
qpoly_t qpolymod_mul(
	qpoly_t * pin1,
	qpoly_t * pin2,
	qpoly_t * paux);

qpoly_t qpolymod_div(
	qpoly_t * pin1,
	qpoly_t * pin2,
	qpoly_t * paux);

qpoly_t qpolymod_recip(
	qpoly_t * pin,
	qpoly_t * paux);

qpoly_t qpolymod_power(
	qpoly_t * px,
	unsigned  power,
	qpoly_t * paux);

#endif // QPOLYMOD_H
