#ifndef ZPN_CONVERT_H
#define ZPN_CONVERT_H

#include "zppoly.h"
#include "zpnpoly.h"

int zpn_convert_find_generators(
	zppoly_aux_t * prs, // Smaller field
	zppoly_aux_t * prl, // Larger field
	zpoly_t      * pgs,
	zpoly_t      * pgl);

int zpn_convert_scalar(
	zpoly_t      * pu1,
	zppoly_aux_t * pr1,
	zpoly_t      * pg1,
	zpoly_t      * pu2,
	zppoly_aux_t * pr2,
	zpoly_t      * pg2);

int zpn_convert_poly(
	zpnpoly_t    * pf1,
	zppoly_aux_t * pr1,
	zpoly_t      * pg1,
	zpnpoly_t    * pf2,
	zppoly_aux_t * pr2,
	zpoly_t      * pg2);

#endif // ZPN_CONVERT_H
