{
	zppoly_t * pout = pvout;
	zppoly_aux_t * paux = pvaux;
	zppoly_t rev;
	int i;
	char ** coeff_stringv[ZPNPOLY_MAX_DEGREE + 1];
	char temp_line[1024];

	pout->degree = 0;
	for (i = 0; i <= ZPNPOLY_MAX_DEGREE; i++)
		pout->coeffs[i] = zppoly_from_base_rep(paux->p, 0);

	strcpy(temp_line, pin);
	pout->degree = tokenize(temp_line, ",", coeff_stringv,
		ZPPOLY_MAX_DEGREE + 1);
	if (pout->degree < 0) {
		fprintf(stderr, "zpnpoly:  Couldn't scan \"%s\".\n",
			pin);
		return 0;
	}

	for (i = 0; i <= pout->degree; i++) {
		if (!zppoly_vscan(coeff_stringv[i],
			&pout->coeffs[pout->degree - i], pvaux))
		{
			fprintf(stderr,
			"zpnpoly:  Couldn't scan coefficient \"%s\".\n",
				pin);
			return 0;
		}
	}

	xxx zppoly vscan

	// xxx need to use tokenize.
	rev.degree = sscanf(pin,
		"%d,%d,%d,%d,%d,%d,%d,%d,%d,%d",
		&rev.coeffs[0], &rev.coeffs[1], &rev.coeffs[2],
		&rev.coeffs[3], &rev.coeffs[4], &rev.coeffs[5],
		&rev.coeffs[6], &rev.coeffs[7], &rev.coeffs[8],
		&rev.coeffs[9]) - 1;
	if (rev.degree < 0) {
	}
	for (i = 0; i <= rev.degree; i++) {
		if ((rev.coeffs[i] < 0) || (rev.coeffs[i] >= paux->p)) {
			fprintf(stderr,
			"zppoly:  coefficient %d out of range 0-%d.\n",
				rev.coeffs[i], paux->p - 1);
			return 0;
		}
	}
	pout->degree = rev.degree;
	for (i = 0; i <= rev.degree; i++)
		pout->coeffs[rev.degree - i] = rev.coeffs[i];
	pout->degree = zppoly_find_degree(pout, pout->degree);
	return 1;
}
