// Elements of the ring Z[x] / (r(x)).  Note that Z[x] is not generally
// euclidean, but it is with respect to monic r(x).  This is used to
// implement cyclotomic integers.

#ifndef ZPOLYMOD_H
#define ZPOLYMOD_H

#include "zpoly.h"

// ----------------------------------------------------------------
zpoly_t zpolymod_mul(
	zpoly_t * pin1,
	zpoly_t * pin2,
	zpoly_t * paux);

zpoly_t zpolymod_power(
	zpoly_t * px,
	unsigned  power,
	zpoly_t * paux);

#endif // ZPOLYMOD_H
