\r ../tools/cpr.gp

print_one_chpol(k, p, n)=
{
	local(M, i, j, val, cp);
	val = k;
	M = matrix(n, n);

	for (i=1, n,
		for (j=1, n,
			M[i,j] = val % p;
			val = val \ p;
		)
	);

	cp = charpoly(M);
	cp = Mod(1,p) * cp;
	if (polisirreducible(cp), print1("*"), print1("."));
	print1(" [D=", lift(Mod(matdet(M), p)), "] ");
	print1(" [R=", matrank(Mod(1,p) *M), "] ");
	\\print1(lift(cp));
	cpr1(cp);
	print1(" = ");
	frs = factor(cp);
	cpr1v1(frs);
	print();
}

p = 2;
n = 4;
top = p ^ (n*n) - 1;
for (k = 0, top, print_one_chpol(k, p, n));
