#include <stdio.h>

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {numbers ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi;
	int m;
	int k;

	if (argc < 2)
		usage(argv[0]);
	for (argi = 1; argi < argc; argi++) {
		if (sscanf(argv[argi], "%d", &m) != 1) {
			fprintf(stderr,
				"Couldn't scan \"%s\" as integer; skipping.\n",
				argv[argi]);
			continue;
		}
		for (k = 1; k <= m; k++) {
			if ((m % k) == 0)
				printf(" %d", k);
		}
		printf("\n");
	}
	return 0;
}
