#include "gcd.h"

// ----------------------------------------------------------------
int calc_gcd(int a, int b)
{
	int r;

	if (a == 0)
		return 0;
	if (b == 0)
		return 0;

	if (a < 0) // Breaks for most negative int (-2^31); I don't care.
		a = -a;
	if (b < 0)
		b = -b;

	while (1) {
		r = a % b;
		if (r == 0)
			break;
		a = b;
		b = r;
	}

	return b;
}
