#include <stdio.h>
#include "gcd.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {numbers ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int m;
	int i, j, jinv;

	if (argc < 2)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &m) != 1) {
		fprintf(stderr,
			"Couldn't scan \"%s\" as integer; skipping.\n",
			argv[1]);
		exit(1);
	}

	for (i = 1; i <= m; i++) {
		if ((m % i) != 0)
			continue;
		//printf("%3d:", i);
		printf("%3d:\n", i);

		//for (j = 1; j <= m; j++) {
			//if (calc_gcd_signed(j, m) == i)
				//printf(" %d", j);
		//}
		//printf("\n");

		for (j = 1; j <= m; j++) {
			if (calc_gcd_signed(j, m) == i) {
				//jinv = calc_inv(j/i, m/i);
				if (calc_gcd_signed(j, m/i) == 1) {
					jinv = calc_inv(j, m/i);
					printf("  %3d %3d\n", j, jinv);
				}
				else {
					printf("  %3d skip\n", j);
				}
			}
		}
		printf("\n");

	}

	return 0;
}
