#include <stdio.h>
#include <stdlib.h>
#include <gcd.h>

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {n}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int n, i, j;

	if (argc != 2)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &n) != 1)
		usage(argv[0]);

	for (i = 0; i <= n; i++) {
		printf("<");
		for (j = 0; j <= n; j++) {
			//printf("%s", (calc_gcd(i*j, n) == 1) ? "*" : " ");
			printf(" %s", (((i*j)%n) == 0) ? "*" : " ");
		}
		printf(">\n");
	}

	return 0;
}
