#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cyclopoly.h"
#include "isprime.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {n}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi, n;
	zpoly_t f;

	if (argc < 2)
		usage(argv[0]);
	for (argi = 1; argi < argc; argi++) {
		if (sscanf(argv[argi], "%d", &n) != 1) {
			fprintf(stderr,
				"Couldn't parse \"%s\" as an integer.\n",
				argv[argi]);
			continue;
		}
		f = zpoly_find_nth_cyclo(n);
		zpoly_print(&f);
		printf("\n");
	}

	return 0;
}
