#include <stdio.h>

// ----------------------------------------------------------------
unsigned calc_gcd(unsigned a, unsigned b)
{
	unsigned r;

	if (a == 0)
		return b;
	if (b == 0)
		return a;

	while (1) {
		r = a % b;
		if (r == 0)
			break;
		a = b;
		b = r;
	}

	return b;
}

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {m} {n}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	unsigned m, n, g;
	if (argc != 3)
		usage(argv[0]);
	if (sscanf(argv[1], "%u", &m) != 1)
		usage(argv[0]);
	if (sscanf(argv[2], "%u", &n) != 1)
		usage(argv[0]);
	g = calc_gcd(m, n);
	printf("%u %u\n", m/g, n/g);
	return 0;
}
