#ifndef GROUP_OPTS_H
#define GROUP_OPTS_H

#include "group.h"

typedef struct _group_opts_spec_t {
	int num_cmd_params;
	int num_file_names;
	int default_verbosity;
	char * cmd_param_desc;
} group_opts_spec_t;

typedef struct _group_opts_t {

	int     verbosity;
	int     echo_inputs;

	int     cmd_paramc;
	char ** cmd_paramv;

	char  * group_spec_desc;
	group_spec_t * pgspec;

	int     auxc;
	char ** auxv;

	int     file_namec;
	char ** file_namev;

} group_opts_t;


int group_parse_opts(
	int                 argc,   // input
	char             ** argv,   // input
	group_opts_spec_t * pospec, // input
	group_opts_t      * popts); // output

void group_opts_usage(
	char * argv0,
	char * cmd_param_desc);

#endif // GROUP_OPTS_H
