#include <stdio.h>
#include <stdlib.h>
#include "error.h"

// ----------------------------------------------------------------
void error(char * msg)
{
	fprintf(stderr, "%s\n", msg);
	exit(1);
}

// ----------------------------------------------------------------
void lerror(int lineno, char * msg)
{
	fprintf(stderr, "line %d: %s\n", lineno, msg);
	exit(1);
}

// ----------------------------------------------------------------
void leerror(int lineno, char * msg, char expect)
{
	fprintf(stderr, "line %d: %s; expected %c\n", lineno, msg, expect);
	exit(1);
}
