#ifndef PARSE_H
#define PARSE_H

#include <stdio.h>
#include "symtab.h"
#include "lexan.h"
#include "stack.h"
#include "opts.h"

typedef struct _parsectx_t {
	lexctx_t lookahead1;
	lexctx_t lookahead2;
} parsectx_t;

void parse(
	parsectx_t * pc,
	symtab_t   * pst,
	stack_t    * ps,
	FILE       * infp,
	opts_t     * popts);

#endif // PARSE_H
