#ifndef STACK_H
#define STACK_H

#define MAX_STACK_SIZE_IN_BYTES 65536

#define STACK_LVALUE 3
#define STACK_RVALUE 4

typedef struct _stack_t {
	int stack_atom_size_in_bytes;
	unsigned char ents[MAX_STACK_SIZE_IN_BYTES];
} stack_t;

void stack_init(stack_t * ps);
int  stack_push(stack_t * ps, void * pval, int nbytes);
int  stack_pop (stack_t * ps, void * pval, int nbytes);

#endif // STACK_H
