#include <stdio.h>
#include "z2ipolymod.h"

int main(int argc, char ** argv)
{
	int n = 4, pn1;
	z2ipoly_t r, a = 1LL, msb;
	unsigned p1, p2;
	unsigned i, diff;

	if (argc >= 2)
		(void)sscanf(argv[1], "%d", &n);
	if (argc >= 3)
		(void)sscanf(argv[2], "%llx", &a);

	pn1 = (1 << n) - 1;
	r = z2ipoly_find_irreducible(n);
	msb = 1LL << n;
	a = z2ipoly_mod(a, r);

	for (i = 0; i < pn1; i++) {
		p1 = a;
		a <<= 1; if (a & msb) a ^= r;
		p2 = a;
		diff = p2 - p1;
		printf("%08x %+5d\n", p1, (int)diff);
	}

	return 0;
}
