#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "factorize.h"

void my_list_primes(int lo, int hi, int verbose, int per_line);

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {n}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi;
	unsigned k, n, nd;
	unsigned * divisors;

	if (argc < 2)
		usage(argv[0]);

	for (argi = 1; argi < argc; argi++) {
		if (sscanf(argv[argi], "%u", &n) != 1) {
			fprintf(stderr, "Couldn't parse \"%s\"; skipping.\n",
				argv[argi]);
			continue;
		}

		printf("%u: ", n);
		divisors = get_all_divisors(n, &nd);
		for (k = 0; k < nd; k++)
			printf(" %u", divisors[k]);
		printf("\n");
	}

	return 0;
}
