#include <stdio.h>
#include "mod.h"
#include "isprime.h"

// ----------------------------------------------------------------
int has_mc(int m, int n)
{
	int t;

	for (t = 2; t < m; t++)
		if (mod_power(t, n, m) == 1)
			return 1;
	return 0;
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int p, q, p2;
	int hi = 20;

	if (argc == 2)
		(void)sscanf(argv[1], "%d", &hi);

	for (p = 2; p < hi; p++) {
		if (!isprime(p))
			continue;
		p2 = p * p;
		for (q = 2; q < hi; q++) {
			if (!isprime(q))
				continue;

			if (has_mc(p2, q))
				printf("%d %d\n", p2, q);
			if (has_mc(q, p2))
				printf("%d %d\n", q, p2);
		}
	}

	return 0;
}
