#include <stdio.h>
#include "mod.h"

// ----------------------------------------------------------------
void do_mn(int m, int n)
{
	int t;
	int count = 0;

	count = 0;
	printf("m=%d n=%d (%d,%d): ", m, n, m%n, n%m);
	fflush(stdout);
	for (t = 2; t < m; t++) {
		if (mod_power(t, n, m) == 1) {
			printf(" t=%d", t);
			fflush(stdout);
			count++;
		}
	}
	printf("\n");
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int m, n;
	int hi = 6;

	if (argc == 3) {
		m = 0; n = 0;
		(void)sscanf(argv[1], "%d", &m);
		(void)sscanf(argv[2], "%d", &n);
		do_mn(m, n);
		return 0;
	}

	if (argc == 2)
		(void)sscanf(argv[1], "%d", &hi);

	for (m = 2; m < hi; m++) {
		for (n = 2; n < hi; n++) {
			do_mn(m, n);
		}
		printf("\n");
	}

	return 0;
}
