#include <stdio.h>
#include <stdlib.h>
#include "mod.h"

// ----------------------------------------------------------------
int do_mn(int m, int n)
{
	int t;

	for (t = 2; t < m; t++)
		if (mod_power(t, n, m) == 1)
			return 1;
	return 0;
}

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {mn[-mnhi]}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int mnlo =  2;
	int mnhi = 20;
	int mn, m, n;
	int ngot;

	if (argc == 2) {
		if (sscanf(argv[1], "%d-%d", &mnlo, &mnhi) == 2)
			;
		else if (sscanf(argv[1], "%d", &mnlo) == 1)
			mnhi = mnlo;
		else
			usage(argv[0]);
	}

	for (mn = mnlo; mn <= mnhi; mn++) {
		ngot = 0;
		printf("%d: ", mn);
		for (m = 2; m < mn; m++) {
			n = mn / m;
			if ((n * m) != mn)
				continue;
			if (do_mn(m, n)) {
				printf(" %d,%d", m, n);
				ngot++;
			}
		}
		if (ngot == 0)
			printf(" --");
		printf("\n");
	}


	return 0;
}
