#include <stdio.h>
#include <stdlib.h>
#include "qpoly.h"
#include "power.h"
#include "malloc_check.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {poly1} {poly2}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	qpoly_t a, b, g;

	if (argc != 3)
		usage(argv[0]);
	if (!qpoly_scan(&a, argv[1]))
		usage(argv[0]);
	if (!qpoly_scan(&b, argv[2]))
		usage(argv[0]);

	g = qpoly_gcd(&a, &b);
	qpoly_print(&g); printf("\n");

	return 0;
}
