#ifndef RING_OPTS_H
#define RING_OPTS_H

#include "ring.h"

typedef struct _ring_opts_spec_t {
	int num_cmd_params;
	int num_file_names;
	int default_verbosity;
	char * cmd_param_desc;
} ring_opts_spec_t;

typedef struct _ring_opts_t {

	int     verbosity;
	int     echo_inputs;

	int     cmd_paramc;
	char ** cmd_paramv;

	char  * ring_spec_desc;
	ring_spec_t * pgspec;

	int     auxc;
	char ** auxv;

	int     file_namec;
	char ** file_namev;

} ring_opts_t;


int ring_parse_opts(
	int                 argc,   // input
	char             ** argv,   // input
	ring_opts_spec_t * pospec, // input
	ring_opts_t      * popts); // output

void ring_opts_usage(
	char * argv0,
	char * cmd_param_desc);

#endif // RING_OPTS_H
