#include <stdio.h>
#include <stdlib.h>
#include "z2ipolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {polys ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t c = 0LL, a = 0LL;
	int argi;

	if (argc < 2)
		usage(argv[0]);

	for (argi = 1; argi < argc; argi++) {
		if (!z2ipoly_scan(&a, argv[argi]))
			usage(argv[0]);
		c = z2ipoly_add(c, a);
	}
	z2ipoly_print(c);
	printf("\n");

	return 0;
}
