#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z2ipolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {n}\n", argv0);
	exit(1);
}

//// ----------------------------------------------------------------
//static void print_compositions(
//	z2ipoly_t r,
//	z2ipoly_t rk,
//	int       do_mod,
//	z2ipoly_t clo,
//	z2ipoly_t chi)
//{
//	z2ipoly_t c, rc;
//
//	if (z2ipoly_is_irreducible(r)) {
//		if (z2ipoly_is_primitive(r)) {
//			printf("p");
//		}
//		else {
//			printf("i");
//		}
//	}
//	else {
//		printf("-");
//	}
//
//	printf(" ");
//	z2ipoly_print(r);
//	for (c = clo; c <= chi; c++) {
//		if (do_mod)
//			rc = z2ipolymod_compose(r, c, rk);
//		else
//			rc = z2ipoly_compose(r, c);
//		printf(" ");
//		z2ipoly_print(rc);
//	}
//	printf("\n");
//}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi, n;
	z2ipoly_t r0;

	if (argc < 2)
		usage(argv[0]);
	for (argi = 1; argi < argc; argi++) {
		if (sscanf(argv[argi], "%d", &n) != 1)
			usage(argv[0]);

		// Search for the first irreducible.
		r0 = z2ipoly_find_irreducible(n);
		printf("%llx\n", r0);

		// xxx use frobits to find the remaining irreds.
		// xxx kode me up ...
	}

	return 0;
}
