#include <stdio.h>
#include <stdlib.h>
#include "z2ipolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {a} {b}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t a, b, c;

	if (argc != 3)
		usage(argv[0]);

	if (!z2ipoly_scan(&a, argv[1]))
		usage(argv[0]);
	if (!z2ipoly_scan(&b, argv[2]))
		usage(argv[0]);
	c = z2ipoly_gcd(a, b);
	z2ipoly_print(c);
	printf("\n");

	return 0;
}
