#include <stdio.h>
#include <stdlib.h>
#include "z2ipolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {r} {polys ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t r, a, b, c;

	if (argc != 4)
		usage(argv[0]);
	if (!z2ipoly_scan(&r, argv[1]))
		usage(argv[0]);
	if (!z2ipoly_scan(&a, argv[2]))
		usage(argv[0]);
	if (!z2ipoly_scan(&b, argv[3]))
		usage(argv[0]);
	a = z2ipoly_mod(a, r);
	b = z2ipoly_mod(b, r);
	c = z2ipolymod_div(a, b, r);
	z2ipoly_print(c);
	printf("\n");

	return 0;
}
