#include <stdio.h>
#include <stdlib.h>
#include "z2ipolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {polys ...} {e} {r}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t c, a, r;
	int power;
	int argi;

	if (argc < 4)
		usage(argv[0]);
	if (sscanf(argv[argc-2], "%d", &power) != 1)
		usage(argv[0]);
	if (!z2ipoly_scan(&r, argv[argc-1]))
		usage(argv[0]);

	for (argi = 1; argi < argc-2; argi++) {
		if (!z2ipoly_scan(&a, argv[argi]))
			usage(argv[0]);
		c = z2ipolymod_power(a, power, r);
		z2ipoly_print(c);
		printf("\n");
	}

	return 0;
}
