#include <stdio.h>
#include <stdlib.h>
#include "z2ipolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {polys ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t r;
	int argi, i, n;

	if (argc < 2)
		usage(argv[0]);

	for (argi = 1; argi < argc; argi++) {
		if (!z2ipoly_scan(&r, argv[argi]))
			usage(argv[0]);
		n = z2ipoly_get_degree(r);
		for (i = n-1; i >= 0; i--)
			if (Z2IPOLY_BIT_AT(r, i))
				printf(" %d", i);
		printf("\n");
	}

	return 0;
}
