#include <stdio.h>
#include <stdlib.h>
#include "gcd.h"
#include "mod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {m} {numbers ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi, a, m, m2, order;

	if (argc < 3)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &m) != 1)
		usage(argv[0]);

	m2 = m * m;
	for (argi = 2; argi < argc; argi++) {
		if (sscanf(argv[argi], "%d", &a) != 1)
			usage(argv[0]);
		if (calc_gcd_signed(a, m2) != 1) {
			order = 0;
		}
		else {
			order = mod_mul_order(a, m2);
		}
		if (argc > 3)
			printf("%d: ", a);
		printf("%d\n", order);
	}

	return 0;
}
