#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {m} {e} {numbers ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi;
	long long m, e, a, ae;

	if (argc < 4)
		usage(argv[0]);
	if (sscanf(argv[1], "%lld", &m) != 1)
		usage(argv[0]);
	if (sscanf(argv[2], "%lld", &e) != 1)
		usage(argv[0]);

	for (argi = 3; argi < argc; argi++) {
		if (sscanf(argv[argi], "%lld", &a) != 1)
			usage(argv[0]);
		ae = mod64_power(a, e, m);
		if (argc > 4)
			printf("%lld^%lld = ", a, e);
		printf("%lld\n", ae);
	}

	return 0;
}
