#include <stdio.h>
#include <stdlib.h>
#include "zppolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {r} {a} {b}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	zpoly_t a, b, q;
	zppoly_aux_t aux;

	if (argc != 5)
		usage(argv[0]);
	if (!zppolymod_auxscan(&aux, argv[1], argv[2]))
		usage(argv[0]);

	if (!zppoly_scan(&a, argv[3], aux.p))
		usage(argv[0]);
	if (!zppoly_scan(&b, argv[4], aux.p))
		usage(argv[0]);
	q = zppolymod_div(&a, &b, &aux);
	zppolymod_print(&q, &aux);
	printf("\n");

	return 0;
}
