#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "zppolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {polys ...} {e}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	zpoly_t c, a;
	int p;
	int power;
	int argi;

	if (argc < 4)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &p) != 1)
		usage(argv[0]);
	if (sscanf(argv[argc-1], "%d", &power) != 1)
		usage(argv[0]);

	for (argi = 2; argi < argc-1; argi++) {
		if (!zppoly_scan(&a, argv[argi], p))
			usage(argv[0]);
		c = zppoly_power(&a, power, p);
		zppoly_print(&c, p);
		printf("\n");
	}

	return 0;
}
