\\xxx need to subtract off lambda I, not just I.

\\----------------------------------------------------------------
make_companion_matrix(f)=
{
	local(n, i, T);
	n = poldegree(f);
	T = matrix(n,n);

	for (i = 1, n-1,
		T[i+1, i] = 1
		);
	for (i = 0, n-1,
		T[1,n-i] = -polcoeff(f, i);
		);

	T *= polcoeff(f, n);
	T /= polcoeff(f, n);
	return(T);
}

\\----------------------------------------------------------------
do_poly(f)=
{
	local(n, k, T, TI, TIk);
	print("--------------------------------------------------------------");

	print("POLY = ", lift(f));
	print();

	n = poldegree(f);
	T = make_companion_matrix(f);
	printp(lift(T), " = T");
	TI = T - matid(n);
	printp(lift(TI), " = TI");
	TIk = TI;
	for (k = 1, n,
		\\printp(lift(TI^k), " = T^", k);
		\\print();
		print1(lift(matker(TI^k)));
		print();
		\\print();
		TIk = TIk * TI;
		);
}

\\----------------------------------------------------------------
p1 = x^4+1;
p2 = x^4+x^2+x+1;
p3 = x^4+x^3+x+1;

p1 = p1 * Mod(1,2);
p2 = p2 * Mod(1,2);
p3 = p3 * Mod(1,2);

do_poly(p1);
do_poly(p2);
do_poly(p3);
