#include <stdio.h>
#include <stdlib.h>
#include "z2ipolymod.h"
#include "z2ilinalg.h"
#include "malloc_check.h"

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t T = 0x13LL;
	z2ipoly_t * M = z2ipoly_companion_matrix(T, 0);
	int i;
	int n = z2ipoly_get_degree(T);
	z2ipoly_t a = 1LL;

	for (i = 0; i < n; i++) {
		z2ipolymod_print(M[i], T);
		printf("\n");
	}
	printf("\n");

	for (i = 0; i < 20; i++) {
		z2ipolymod_print(a, T);
		printf("\n");
		a = z2ila_mx_times_vr(M, n, a);
	}

	free(M);
	return 0;
}
