#include <stdio.h>
#include <stdlib.h>
#include "gcd.h"
#include "phi.h"
#include "inv.h"

// ----------------------------------------------------------------
static char usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {x} {m}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int m;
	int x;
	int xi;

	if (argc != 3)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &x) != 1)
		usage(argv[0]);
	if (sscanf(argv[2], "%d", &m) != 1)
		usage(argv[0]);

	xi = calc_inv(x, m);
	printf("%d\n", xi);

	return 0;
}
