#ifndef ISQRT_H
#define ISQRT_H

#include "intfc.h"

// want_ceil is either IFLOOR or ICEIL

// ----------------------------------------------------------------
unsigned calc_isqrt_32(
	unsigned n,
	int want_ceil);

unsigned long long calc_isqrt_64(
	unsigned long long n,
	int want_ceil);

// ----------------------------------------------------------------
unsigned calc_isqrt_bisect_32(
	unsigned n,
	int want_ceil);

unsigned long long calc_isqrt_bisect_64(
	unsigned long long n,
	int want_ceil);

#endif // ISQRT_H
