#ifndef ISQRT_UBIG_H
#define ISQRT_UBIG_H

#include "ubig.h"
#include "intfc.h"

// want_ceil is either IFLOOR or ICEIL

ubig calc_isqrt_ubig(
	ubig * pn,
	int want_ceil);

ubig calc_isqrt_bisect_ubig(
	ubig * pn,
	int want_ceil);

ubig calc_isqrt_newton_ubig(
	ubig * pn,
	int want_ceil);

#endif // ISQRT_UBIG_H
