#ifndef LEGSYM_H
#define LEGSYM_H

// Returns:
// *  1 if x is a quadratic residue mod p.
// * -1 if x is a quadratic non-residue mod p.
// *  0 if x is 0 mod p.

// It is assumed that p is prime; no check is made.
int calc_legsym_32(
	unsigned x,
	unsigned p);

int calc_legsym_64(
	unsigned long long x,
	unsigned long long p);

#endif // LEGSYM_H
