#include "moebius.h"
#include "factorize.h"

// ----------------------------------------------------------------
int calc_moebius_unsigned(
	unsigned n)
{
	factor_info_t finfo;
	int i;
	int rv = 1;

	if (n == 1)
		return 1;

	calc_factors(n, &finfo);

	for (i = 0; i < finfo.num_distinct; i++) {
		if (finfo.factors[i].count > 1)
			return 0;
		rv *= -1;
	}
	return rv;
}

// ----------------------------------------------------------------
int calc_moebius_unsigned_ll(
	unsigned long long n)
{
	return 999LL;
}
