#include "gcd.h"
#include "phi.h"

// ----------------------------------------------------------------
int calc_phi_signed(int n)
{
	int phi = 0;
	int i;

	phi = 0;
	for (i = 1; i < n; i++) {
		if (calc_gcd_signed(n, i) == 1)
			phi++;
	}

	return phi;
}

// ----------------------------------------------------------------
unsigned calc_phi_unsigned(unsigned n)
{
	unsigned phi = 0;
	unsigned i;

	phi = 0;
	for (i = 1; i < n; i++) {
		if (calc_gcd_signed(n, i) == 1)
			phi++;
	}

	return phi;
}

// ----------------------------------------------------------------
long long calc_phi_signed_ll(long long n)
{
	long long phi = 0;
	long long i;

	phi = 0;
	for (i = 1; i < n; i++) {
		if (calc_gcd_signed(n, i) == 1)
			phi++;
	}

	return phi;
}

// ----------------------------------------------------------------
unsigned long long calc_phi_unsigned_ll(unsigned long long n)
{
	unsigned long long phi = 0;
	unsigned long long i;

	phi = 0;
	for (i = 1; i < n; i++) {
		if (calc_gcd_signed(n, i) == 1)
			phi++;
	}

	return phi;
}
