#include <stdio.h>
#include <stdlib.h>
#include "factorize.h"
#include "isprime.h"
#include "mod.h"

typedef long long i64;

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	i64 lo = 2;
	i64 hi = 20;
	i64 p, p2, i = 0, j = 0, a, prod, first;

	if (argc == 2) {
		(void)sscanf(argv[1], "%lld", &hi);
		lo = hi;
	}
	if (argc == 3) {
		(void)sscanf(argv[1], "%lld", &lo);
		(void)sscanf(argv[2], "%lld", &hi);
	}

	for (p = lo; p <= hi; p++) {
		if (!isprime(p))
			continue;
		p2 = p * p;

#if 1
		first = 1;
		for (i = 1; i < p-1; i++) {
			prod = 1;
			for (j = 0; j < p; j++) {
				a = i + p*j + 1;
				prod *= a;
				prod %= p2;
			}
			if (prod < p) {
				if (first) {
					printf("\n");
					printf("%lld:\n", p);
				}
				printf("%lld %lld\n", i, prod);
				first = 0;
			}
		}
		fflush(stdout); // in case redirected
#else
		i = j;
		prod = 1;
		for (a = 2; a < p2; a += p) {
			prod *= a;
			prod %= p2;
			//printf(" %lld", a);
		}
		if (prod < p)
			printf("%lld: %lld\n", p, prod);
#endif
	}

	return 0;
}
