#ifndef AUTCK_H
#define AUTCK_H

typedef void vop_t(
	void * pin1,
	void * pin2,
	void * pout,
	void * paux);

typedef int vequal_t(
	void * pin1,
	void * pin2,
	void * paux);

typedef void vprint_t(
	void * pin,
	void * paux);

typedef void vindex_to_element_t(
	int    which,
	void * paux,
	void * pelement);

int num_automorphisms(
	void            * velements,
	int               num_elements,
	int               element_size,
	void            * paux,
	vop_t    * pvop,
	vequal_t * pvequal,
	vindex_to_element_t * pvindex_to_element,
	vprint_t        * pvprint,
	int               verbosity);

int is_automorphism(
	void            * vunpermuted_elements,
	void            * vpermuted_elements,
	int               num_elements,
	int               element_size,
	void            * paux,
	vop_t    * pvop,
	vequal_t * pvequal,
	vindex_to_element_t * pvindex_to_element,
	vprint_t        * pvprint,
	int               verbosity);

#endif // AUTCK_H
