#ifndef RING_FILE_H
#define RING_FILE_H

#include <stdio.h>
#include "ring.h"

int fill_ring_from_file(
	ring_t * pring,           // input
	ring_spec_t * pspec,       // input
	void    * pvaux,            // input
	char    * elements_file,    // input
	void    * elements_buffer,  // output
	int       max_ring_bytes); // output

int fill_ring_from_stream(
	ring_t * pring,           // input
	ring_spec_t * pspec,       // input
	void    * pvaux,            // input
	FILE    * elements_fp,      // input
	void    * elements_buffer,  // output
	int       max_ring_bytes); // output

#endif // RING_FILE_H
