#ifndef METACYC_H
#define METACYC_H

#include "group.h"

typedef struct _metacyc_t {
	int ppow;
	int qpow;
} metacyc_t;

metacyc_t metacyc_mul  (metacyc_t a, metacyc_t b, int p, int q, int t);
int       metacyc_equal(metacyc_t a, metacyc_t b);

extern group_spec_t metacyc_group_spec;

#endif // METACYC_H
