#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "triv.h"

// ----------------------------------------------------------------
int triv_mul(int a, int b)
{
	return 0;
}

// ----------------------------------------------------------------
int triv_equal(int a, int b)
{
	return 1;
}

// ----------------------------------------------------------------
static void triv_vmul(
	void * pvout,
	void * pvin1,
	void * pvin2,
	void * pvaux)
{
	*(int *)pvout = 0;
}

// ----------------------------------------------------------------
static int triv_vequal(
	void * pvin1,
	void * pvin2,
	void * pvaux)
{
	return 1;
}

// ----------------------------------------------------------------
static int triv_vless(
	void * pvin1,
	void * pvin2,
	void * pvaux)
{
	return 0;
}

// ----------------------------------------------------------------
static void triv_vprint(
	void * pvin,
	void * pvaux)
{
	printf("e");
}

// ----------------------------------------------------------------
int triv_vscan(
	void * pvout,
	char * pin,
	void * pvaux,
	int    max_elt_bytes)
{
	if (sizeof(int) > max_elt_bytes) {
		fprintf(stderr, "triv:  Need %d bytes for element.\n",
			sizeof(int));
		exit(1);
	}


	if (strcmp(pin, "e") == 0) {
		*(int *)pvout = 1;
		return 1;
	}
	else {
		return 0;
	}
}

// ----------------------------------------------------------------
int triv_vauxscan(
	void *  pvaux,
	int     argc,
	char ** argv,
	int     max_aux_bytes)
{
	if (argc != 0)
		return 0;
	return 1;
}


// ----------------------------------------------------------------
int  triv_fill_group(
	void * pvelements,
	void * pvaux,
	int    max_group_bytes,
	int  * pnum_elements)
{
	int * pelements = (int *) pvelements;
	int m = 1;

	if (m > max_group_bytes/sizeof(int))
		return 0;
	pelements[0] = 0;
	*pnum_elements = m;
	return 1;
}

// ================================================================
group_spec_t triv_group_spec = {
	element_size  : sizeof(int),
	naux          : 0,
	pvop          : triv_vmul,
	pvequal       : triv_vequal,
	pvless        : triv_vless,
	pvprint       : triv_vprint,
	pvauxprint     : 0,
	pvscan        : triv_vscan,
	pvauxscan      : triv_vauxscan,
	pfill_group   : triv_fill_group,
	desc          : "triv"
};
