// Direct products of Z2 with itself, n times.

#ifndef Z2N_H
#define Z2N_H

int z2n_add (int a, int b, int n);
int z2n_minus(int a, int b, int n);
int z2n_mul  (int a, int b, int n);
int z2n_quot (int a, int b, int n);
int z2n_rem  (int a, int b, int n);
int z2n_recip(int a, int n);
int z2n_equal(int a, int b, int n);

void z2n_vadd(
	void * pvout,
	void * pvin1,
	void * pvin2,
	void * pvaux);

int z2n_vequal(
	void * pvin1,
	void * pvin2,
	void * pvaux);

void z2n_vprint(
	void * pvin,
	void * pvaux);

void z2n_vindex_to_element(
	int    which,
	void * pvn,
	void * pvelement);

#endif // Z2N_H
