#ifndef Z2N_CONVERT_H
#define Z2N_CONVERT_H

#include "z2poly.h"
#include "z2npoly.h"

int z2n_convert_find_generators(
	z2poly_t  * prs, // Smaller field
	z2poly_t  * prl, // Larger field
	z2poly_t  * pgs,
	z2poly_t  * pgl);

int z2n_convert_scalar(
	z2poly_t  * pu1,
	z2poly_t  * pr1,
	z2poly_t  * pg1,
	z2poly_t  * pu2,
	z2poly_t  * pr2,
	z2poly_t  * pg2);

int z2n_convert_poly(
	z2npoly_t * pf1,
	z2poly_t  * pr1,
	z2poly_t  * pg1,
	z2npoly_t * pf2,
	z2poly_t  * pr2,
	z2poly_t  * pg2);

#endif // Z2N_CONVERT_H
