#ifndef Z2NI_CONVERT_H
#define Z2NI_CONVERT_H

#include "z2ipoly.h"
#include "z2nipoly.h"

int z2ni_convert_find_generators(
	z2ipoly_t   rs, // Smaller field
	z2ipoly_t   rl, // Larger field
	z2ipoly_t * pgs,
	z2ipoly_t * pgl);

int z2ni_convert_scalar(
	z2ipoly_t   u1,
	z2ipoly_t   r1,
	z2ipoly_t   g1,
	z2ipoly_t * pu2,
	z2ipoly_t   r2,
	z2ipoly_t   g2);

int z2ni_convert_poly(
	z2nipoly_t * pf1,
	z2ipoly_t    r1,
	z2ipoly_t    g1,
	z2nipoly_t * pf2,
	z2ipoly_t    r2,
	z2ipoly_t    g2);

#endif // Z2NI_CONVERT_H
