#ifndef ZMX_H
#define ZMX_H

#include "group.h"

// ----------------------------------------------------------------
#define ZMX_MAX_PARTS 10
typedef struct _zmx_t {
	int num_parts;
	int parts[ZMX_MAX_PARTS];
} zmx_t;

// ----------------------------------------------------------------
zmx_t zmx_add(zmx_t a, zmx_t b, zmx_t m);
zmx_t zmx_mul(zmx_t a, zmx_t b, zmx_t m);
int zmx_equal(zmx_t a, zmx_t b, zmx_t m);

extern group_spec_t zmx_add_group_spec;
extern group_spec_t zmx_mul_group_spec;

#endif // ZMX_H
