#include <stdio.h>
#include <stdlib.h>

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {m}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int m = 0;
	int x, x2;

	if (argc < 2)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &m) != 1)
		usage(argv[0]);

	for (x = 0; x < m; x++) {
		x2 = (x * x) % m;
		if (argc > 2) {
			printf("%4d^2 = %4d", x, x2);
			if (x == x2)
				printf(" *");
			printf("\n");
		}
		else {
			if (x == x2)
				printf("%d\n", x);
				//printf("m=%4d m-1=%4d\n", x, x-1);
		}
	}

	return 0;
}
