#include <stdio.h>
unsigned poly, mask;
int main(int argc, char ** argv)
{
	unsigned r, i,  j, limit, Lc;
	if (argc < 2) {
		printf("Usage: %s {degree}\n", argv[0]);
		exit(1);
	}
	r = (unsigned)atoi(argv[1]);
	mask = 1 << (r-1);
	limit = mask << 1;

	for (i = 1; i < limit;  i+= 2) {
		poly = i;
		j = pred(1, 0);
		Lc = 1;
		while (pred(1, j) != 0) {
			Lc++;
			j = pred(0, j);
		}
		if (Lc == (limit-1))
			printf("%x\n", i | limit);
	}

	return 0;
}

int pred(unsigned x, unsigned y)
{
	if ((y & mask) > 0) {
		if (x == 1)
			return ((y << 1) & (2 * mask - 1));
		else
			return (((y << 1) ^ poly) & (2 * mask - 1));
	}
	else {
		if (x == 0)
			return ((y << 1) & (2 * mask - 1));
		else
			return (((y << 1) ^ poly) & (2 * mask - 1));
	}
}
