#include <stdio.h>

// ----------------------------------------------------------------
int main(void)
{
	int add_table[26][26];
	int sub_table[26][26];
	int mul_table[26][26];
	int div_table[26][26];
	int neg_table[26];
	int recip_table[26];
	int x, y, z;

	//  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	for (x = 0; x < 26; x++) {
		for (y = 0; y < 26; y++) {
			z = (x + y) % 26;
			add_table[x][y] = z;
		}
	}

	for (x = 0; x < 26; x++) {
		z = 26 - x;
		if (z == 26)
			z = 0;
		neg_table[x] = z;
	}

	for (x = 0; x < 26; x++) {
		for (y = 0; y < 26; y++) {
			z = (52 + x - y) % 26;
			sub_table[x][y] = z;
		}
	}

	for (x = 0; x < 26; x++) {
		for (y = 0; y < 26; y++) {
			z = (x * y) % 26;
			mul_table[x][y] = z;
		}
	}

	for (x = 0; x < 26; x++) {
		recip_table[x] = -1;
		for (y = 0; y < 26; y++) {
			if (mul_table[x][y] == 1)
				recip_table[x] = y;
		}
	}

	for (x = 0; x < 26; x++) {
		for (y = 0; y < 26; y++) {
			if (recip_table[y] == -1)
				div_table[x][y] = -1;
			else
				div_table[x][y] = mul_table[x][recip_table[y]];
		}
	}

	//  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	printf("static char add_table[26][27] = {\n");
	for (x = 0; x < 26; x++) {
		printf("\t\"");
		for (y = 0; y < 26; y++) {
			printf("%c", add_table[x][y] + 'A');
		}
		printf("\",\n");
	}
	printf("};\n");
	printf("\n");

	printf("static char sub_table[26][27] = {\n");
	for (x = 0; x < 26; x++) {
		printf("\t\"");
		for (y = 0; y < 26; y++) {
			printf("%c", sub_table[x][y] + 'A');
		}
		printf("\",\n");
	}
	printf("};\n");
	printf("\n");

	printf("static char mul_table[26][27] = {\n");
	for (x = 0; x < 26; x++) {
		printf("\t\"");
		for (y = 0; y < 26; y++) {
			printf("%c", mul_table[x][y] + 'A');
		}
		printf("\",\n");
	}
	printf("};\n");
	printf("\n");

	printf("static char div_table[26][27] = {\n");
	for (x = 0; x < 26; x++) {
		printf("\t\"");
		for (y = 0; y < 26; y++) {
			printf("%c", div_table[x][y] + 'A');
		}
		printf("\",\n");
	}
	printf("};\n");
	printf("\n");

	printf("static char neg_table[27] = \"");
	for (x = 0; x < 26; x++) {
		printf("%c", neg_table[x] + 'A');
	}
	printf("\";\n");
	printf("\n");

	printf("static char recip_table[27] = \"");
	for (x = 0; x < 26; x++) {
		printf("%c", recip_table[x] + 'A');
	}
	printf("\";\n");
	printf("\n");

	return 0;
}
