static char add_table[26][27] = {
	"ABCDEFGHIJKLMNOPQRSTUVWXYZ",
	"BCDEFGHIJKLMNOPQRSTUVWXYZA",
	"CDEFGHIJKLMNOPQRSTUVWXYZAB",
	"DEFGHIJKLMNOPQRSTUVWXYZABC",
	"EFGHIJKLMNOPQRSTUVWXYZABCD",
	"FGHIJKLMNOPQRSTUVWXYZABCDE",
	"GHIJKLMNOPQRSTUVWXYZABCDEF",
	"HIJKLMNOPQRSTUVWXYZABCDEFG",
	"IJKLMNOPQRSTUVWXYZABCDEFGH",
	"JKLMNOPQRSTUVWXYZABCDEFGHI",
	"KLMNOPQRSTUVWXYZABCDEFGHIJ",
	"LMNOPQRSTUVWXYZABCDEFGHIJK",
	"MNOPQRSTUVWXYZABCDEFGHIJKL",
	"NOPQRSTUVWXYZABCDEFGHIJKLM",
	"OPQRSTUVWXYZABCDEFGHIJKLMN",
	"PQRSTUVWXYZABCDEFGHIJKLMNO",
	"QRSTUVWXYZABCDEFGHIJKLMNOP",
	"RSTUVWXYZABCDEFGHIJKLMNOPQ",
	"STUVWXYZABCDEFGHIJKLMNOPQR",
	"TUVWXYZABCDEFGHIJKLMNOPQRS",
	"UVWXYZABCDEFGHIJKLMNOPQRST",
	"VWXYZABCDEFGHIJKLMNOPQRSTU",
	"WXYZABCDEFGHIJKLMNOPQRSTUV",
	"XYZABCDEFGHIJKLMNOPQRSTUVW",
	"YZABCDEFGHIJKLMNOPQRSTUVWX",
	"ZABCDEFGHIJKLMNOPQRSTUVWXY",
};

static char sub_table[26][27] = {
	"AZYXWVUTSRQPONMLKJIHGFEDCB",
	"BAZYXWVUTSRQPONMLKJIHGFEDC",
	"CBAZYXWVUTSRQPONMLKJIHGFED",
	"DCBAZYXWVUTSRQPONMLKJIHGFE",
	"EDCBAZYXWVUTSRQPONMLKJIHGF",
	"FEDCBAZYXWVUTSRQPONMLKJIHG",
	"GFEDCBAZYXWVUTSRQPONMLKJIH",
	"HGFEDCBAZYXWVUTSRQPONMLKJI",
	"IHGFEDCBAZYXWVUTSRQPONMLKJ",
	"JIHGFEDCBAZYXWVUTSRQPONMLK",
	"KJIHGFEDCBAZYXWVUTSRQPONML",
	"LKJIHGFEDCBAZYXWVUTSRQPONM",
	"MLKJIHGFEDCBAZYXWVUTSRQPON",
	"NMLKJIHGFEDCBAZYXWVUTSRQPO",
	"ONMLKJIHGFEDCBAZYXWVUTSRQP",
	"PONMLKJIHGFEDCBAZYXWVUTSRQ",
	"QPONMLKJIHGFEDCBAZYXWVUTSR",
	"RQPONMLKJIHGFEDCBAZYXWVUTS",
	"SRQPONMLKJIHGFEDCBAZYXWVUT",
	"TSRQPONMLKJIHGFEDCBAZYXWVU",
	"UTSRQPONMLKJIHGFEDCBAZYXWV",
	"VUTSRQPONMLKJIHGFEDCBAZYXW",
	"WVUTSRQPONMLKJIHGFEDCBAZYX",
	"XWVUTSRQPONMLKJIHGFEDCBAZY",
	"YXWVUTSRQPONMLKJIHGFEDCBAZ",
	"ZYXWVUTSRQPONMLKJIHGFEDCBA",
};

static char mul_table[26][27] = {
	"AAAAAAAAAAAAAAAAAAAAAAAAAA",
	"ABCDEFGHIJKLMNOPQRSTUVWXYZ",
	"ACEGIKMOQSUWYACEGIKMOQSUWY",
	"ADGJMPSVYBEHKNQTWZCFILORUX",
	"AEIMQUYCGKOSWAEIMQUYCGKOSW",
	"AFKPUZEJOTYDINSXCHMRWBGLQV",
	"AGMSYEKQWCIOUAGMSYEKQWCIOU",
	"AHOVCJQXELSZGNUBIPWDKRYFMT",
	"AIQYGOWEMUCKSAIQYGOWEMUCKS",
	"AJSBKTCLUDMVENWFOXGPYHQZIR",
	"AKUEOYISCMWGQAKUEOYISCMWGQ",
	"ALWHSDOZKVGRCNYJUFQBMXITEP",
	"AMYKWIUGSEQCOAMYKWIUGSEQCO",
	"ANANANANANANANANANANANANAN",
	"AOCQESGUIWKYMAOCQESGUIWKYM",
	"APETIXMBQFUJYNCRGVKZODSHWL",
	"AQGWMCSIYOEUKAQGWMCSIYOEUK",
	"ARIZQHYPGXOFWNEVMDULCTKBSJ",
	"ASKCUMEWOGYQIASKCUMEWOGYQI",
	"ATMFYRKDWPIBUNGZSLEXQJCVOH",
	"AUOICWQKEYSMGAUOICWQKEYSMG",
	"AVQLGBWRMHCXSNIDYTOJEZUPKF",
	"AWSOKGCYUQMIEAWSOKGCYUQMIE",
	"AXUROLIFCZWTQNKHEBYVSPMJGD",
	"AYWUSQOMKIGECAYWUSQOMKIGEC",
	"AZYXWVUTSRQPONMLKJIHGFEDCB",
};

static char div_table[26][27] = {
	"@A@A@A@A@A@A@@@A@A@A@A@A@A",
	"@B@J@V@P@D@T@@@H@X@L@F@R@Z",
	"@C@S@Q@E@G@M@@@O@U@W@K@I@Y",
	"@D@B@L@T@J@F@@@V@R@H@P@Z@X",
	"@E@K@G@I@M@Y@@@C@O@S@U@Q@W",
	"@F@T@B@X@P@R@@@J@L@D@Z@H@V",
	"@G@C@W@M@S@K@@@Q@I@O@E@Y@U",
	"@H@L@R@B@V@D@@@X@F@Z@J@P@T",
	"@I@U@M@Q@Y@W@@@E@C@K@O@G@S",
	"@J@D@H@F@B@P@@@L@Z@V@T@X@R",
	"@K@M@C@U@E@I@@@S@W@G@Y@O@Q",
	"@L@V@X@J@H@B@@@Z@T@R@D@F@P",
	"@M@E@S@Y@K@U@@@G@Q@C@I@W@O",
	"@N@N@N@N@N@N@@@N@N@N@N@N@N",
	"@O@W@I@C@Q@G@@@U@K@Y@S@E@M",
	"@P@F@D@R@T@Z@@@B@H@J@X@V@L",
	"@Q@O@Y@G@W@S@@@I@E@U@C@M@K",
	"@R@X@T@V@Z@L@@@P@B@F@H@D@J",
	"@S@G@O@K@C@E@@@W@Y@Q@M@U@I",
	"@T@P@J@Z@F@X@@@D@V@B@R@L@H",
	"@U@Y@E@O@I@Q@@@K@S@M@W@C@G",
	"@V@H@Z@D@L@J@@@R@P@X@B@T@F",
	"@W@Q@U@S@O@C@@@Y@M@I@G@K@E",
	"@X@Z@P@H@R@V@@@F@J@T@L@B@D",
	"@Y@I@K@W@U@O@@@M@G@E@Q@S@C",
	"@Z@R@F@L@X@H@@@T@D@P@V@J@B",
};

static char neg_table[27] = "AZYXWVUTSRQPONMLKJIHGFEDCB";

static char recip_table[27] = "@B@J@V@P@D@T@@@H@X@L@F@R@Z";

