#include <stdio.h>
#include <stdlib.h>
#include "z3poly.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {base-27 polys ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z3poly_t z;
	int argi;
	if (argc < 2)
		usage(argv[0]);
	for (argi = 1; argi < argc; argi++) {
		if (!z3poly_scan_base_27(&z, argv[argi]))
			usage(argv[0]);
		z3poly_print_base_3(&z);
		printf("\n");
	}
	return 0;
}
