show_evals(polys, exponent, rc)=
{
	local(count, i, z);
	count = length(polys);
	for (i = 1, count,
		z = lift(lift(
			Mod(y=subst(subst(polys[i],x,b),a,b^exponent), rc)));
		if (z == 0,
			print1(">>> "),
			print1("    "));
		print(lift(lift(polys[i])));
		\\print(lift(y));
		);
}

\\ ----------------------------------------------------------------
rc=Mod(1,2)*(b^6+b+1);

\\ ----------------------------------------------------------------
\\ z2nimin 7 43
\\   rr=1:1:3:2 g=1:0
\\   rr=1:1:2:3 g=1:0

\\ ----------------------------------------------------------------
\\ z2nifactor 7 43
\\ 1:1:2:3
\\ 1:1:3:2

rrs=vector(2);

rrs[1]=Mod(1,2)*(x^3 + x^2 + (a+1)*x +   a);
rrs[2]=Mod(1,2)*(x^3 + x^2 +     a*x + a+1);

print("F26 over F22, search/factor:");
show_evals(rrs, 21, rc);
print("");

\\ ----------------------------------------------------------------
\\ z2nimin b 43
\\   rr=1:5:2 g=1:0
\\   rr=1:2:7 g=1:0
\\   rr=1:4:3 g=1:0
\\   rr=1:6:5 g=1:0

rrs=vector(4);

rrs[1]=Mod(1,2)*(x^2 + (a^2  +1)*x +     a);
rrs[2]=Mod(1,2)*(x^2 +      a   *x + a^2+a+1);
rrs[3]=Mod(1,2)*(x^2 + (a^2    )*x +     a+1);
rrs[4]=Mod(1,2)*(x^2 + (a^2+a  )*x + a^2+1);

print("F26 over F23, search:");
show_evals(rrs, 9, rc);
print("");

\\ ----------------------------------------------------------------
\\ z2nifactor b 43
\\  1:2:7
\\  1:4:3
\\  1:6:5

rrs=vector(3);

rrs[1]=Mod(1,2)*(x^2 +      a   *x + a^2+a+1);
rrs[2]=Mod(1,2)*(x^2 + (a^2    )*x +     a+1);
rrs[3]=Mod(1,2)*(x^2 + (a^2+a  )*x + a^2+1);

print("F26 over F23, factor:");
show_evals(rrs, 9, rc);
print("");
