\\ alpha = gamma^21
\\ beta  = gamma^9
\\ gamma is a root of gamma^6 + gamma + 1
\\ gamma is a root of gamma^63 -  1
ra = Mod(1,2) * (a^2+a+1);
rb = Mod(1,2) * (b^3+b+1);
rc = Mod(1,2) * (c^6+c+1);
rm = Mod(1,2) * (c^6+c^5+c^3+c^2+1);
uc = Mod(1,2) * (c^63-1);

pa1 = Mod(1,2)*((      b    ) * a + (b^2 + b + 1));
pa2 = Mod(1,2)*((b^2     + 1) * a + (      b    ));
pa3 = Mod(1,2)*((b^2 + b + 1) * a + (b^2     + 1));

pb1 = Mod(1,2)*((  1) * b^2 + (a+1) * b + (  1));
pb2 = Mod(1,2)*((a  ) * b^2 + (  1) * b + (a  ));
pb3 = Mod(1,2)*((a+1) * b^2 + (a  ) * b + (a+1));

q1 = subst(subst(pa1, a, c^21), b, c^9);
q2 = subst(subst(pa2, a, c^21), b, c^9);
q3 = subst(subst(pa3, a, c^21), b, c^9);
q4 = subst(subst(pb1, a, c^21), b, c^9);
q5 = subst(subst(pb2, a, c^21), b, c^9);
q6 = subst(subst(pb3, a, c^21), b, c^9);

print("ab->c");
lift(q1)
lift(q2)
lift(q3)
lift(q4)
lift(q5)
lift(q6)
print("");

r1 = subst(rc, c, q1);
r2 = subst(rc, c, q2);
r3 = subst(rc, c, q3);
r4 = subst(rc, c, q4);
r5 = subst(rc, c, q5);
r6 = subst(rc, c, q6);

mcr1 = lift(Mod(r1, rc));
mcr2 = lift(Mod(r2, rc));
mcr3 = lift(Mod(r3, rc));
mcr4 = lift(Mod(r4, rc));
mcr5 = lift(Mod(r5, rc));
mcr6 = lift(Mod(r6, rc));

print("mc");
lift(mcr1)
lift(mcr2)
lift(mcr3)
lift(mcr4)
lift(mcr5)
lift(mcr6)
print("");

mmr1 = lift(Mod(r1, rm));
mmr2 = lift(Mod(r2, rm));
mmr3 = lift(Mod(r3, rm));
mmr4 = lift(Mod(r4, rm));
mmr5 = lift(Mod(r5, rm));
mmr6 = lift(Mod(r6, rm));

print("mm");
lift(mmr1)
lift(mmr2)
lift(mmr3)
lift(mmr4)
lift(mmr5)
lift(mmr6)
print("");

u1 = subst(uc, c, q1);
u2 = subst(uc, c, q2);
u3 = subst(uc, c, q3);
u4 = subst(uc, c, q4);
u5 = subst(uc, c, q5);
u6 = subst(uc, c, q6);

muu1 = lift(Mod(u1, uc));
muu2 = lift(Mod(u2, uc));
muu3 = lift(Mod(u3, uc));
muu4 = lift(Mod(u4, uc));
muu5 = lift(Mod(u5, uc));
muu6 = lift(Mod(u6, uc));

print("mu");
lift(muu1)
lift(muu2)
lift(muu3)
lift(muu4)
lift(muu5)
lift(muu6)
print("");
