// This is the stupidest, brute-force, sledgehammer approach to factoring
// Gaussian integers into pairs.

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gint.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {re,im}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi;
	gint_t g;
	gint_t a, b, c;
	int nf;
	int N;

	if (argc < 2)
		usage(argv[0]);

	for (argi = 1; argi < argc; argi++) {
		// xxx make a vscan, vprint.
		if (sscanf(argv[argi], "%d,%d", &g.re, &g.im) != 2) {
			g.im = 0;
			if (sscanf(argv[argi], "%d", &g.re) != 1) {
				fprintf(stderr,
					"Couldn't parse \"%s\"; skipping.\n",
					argv[argi]);
				continue;
			}
		}

		N = gint_norm(g);

		// The Gaussian integers are a euclidean ring.  So, I should
		// implement a division algorithm.  This crude hack will
		// suffice for now.

		nf = 0;

		for (a.re = -N; a.re <= N; a.re++) {
		for (a.im = -N; a.im <= N; a.im++) {
		for (b.re = -N; b.re <= N; b.re++) {
		for (b.im = -N; b.im <= N; b.im++) {

			if (a.re == 0) {
				if (a.im ==  1)
					continue;
				if (a.im == -1)
					continue;
			}

			if (a.im == 0) {
				if (a.re ==  1)
					continue;
				if (a.re == -1)
					continue;
			}

			// Needs is-unit function
			if (b.re == 0) {
				if (b.im ==  1)
					continue;
				if (b.im == -1)
					continue;
			}

			if (b.im == 0) {
				if (b.re ==  1)
					continue;
				if (b.re == -1)
					continue;
			}

			c = gint_mul(a, b);
			if (gint_equal(g, c)) {
				nf++;
				printf("%3d,%3d * %3d,%3d = %3d,%3d\n",
					a.re, a.im,
					b.re, b.im,
					c.re, c.im);
			}
		}
		}
		}
		}

		if (nf == 0)
			printf("%3d, %3d is prime\n", g.re, g.im);
	}

	return 0;
}
