#include <stdio.h>
#include <stdlib.h>

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int niter = 10, i;
	unsigned reg = 1;
	unsigned mask = 0x000000af;

	if (argc >= 2)
		niter = atoi(argv[1]);

	// 1000 0000 0000 0000  0000 0000 0101 0111 (1)
	// (1) 0000 0000 0000 0000 0000 0000 1010 1111

	for (i = 0; i < niter; i++) {
		printf("%08x\n", reg);
		if (reg & 0x80000000) {
			if (argc == 2)
				reg = ((reg ^ mask) << 1) | 1;
			else
				reg = ((reg << 1) ^ mask) | 1;
		}
		else {
			reg <<= 1;
		}
	}


	return 0;
}
