#include <stdio.h>
#include <stdlib.h>

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int p, a, b, x, y;

	if (argc != 2)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &p) != 1)
		usage(argv[0]);

	for (a = 1; a < p; a++) {
		for (b = 0; b < p; b++) {
			//printf("%2d * x + %2d: ", a, b);
			for (x = 0; x < p; x++) {
				y = (a * x + b) % p;
				//printf(" %2d", y);
				if (x > 0)
					printf(",");
				printf("%d", y + 1); // [1 .. p] in S_p
			}
			printf("\n");
		}
	}

	return 0;
}
