#ifndef OPTS_H
#define OPTS_H

#include <stdio.h>
#include "ops.h"
#include "symtab.h"

typedef struct _opts_t {
	ops_t * pops;
	void  * pvtopts;
	char    aux_buf[MAX_AUX_SIZE];

	int req_semi;
} opts_t;

void opts_default (opts_t * popts);
int  opts_override(opts_t * popts, int argc, char ** argv,
	symtab_t * pst);
void opts_usage   (char * argv0);

#endif // OPTS_H
