// try:
// 12 1ff vs. 12 2
// 14 9
// 11 7ff
// 13 ede
// 13 ff3
// 13 ff8
// 13 7df
// 13 ff0
// 13 1ffd
// 13 fff *
// 14 fff
// ech: 14 3
// rand: 12 1ff, 14 333c

#include <stdio.h>
#include "z2ipolymod.h"

int main(int argc, char ** argv)
{
	int n = 4, pn1;
	z2ipoly_t r, a0 = 2LL, a;
	unsigned p1, p2;
	unsigned i;
	int diff;

	if (argc >= 2)
		(void)sscanf(argv[1], "%d", &n);
	if (argc >= 3)
		(void)sscanf(argv[2], "%llx", &a0);

	pn1 = (1 << n) - 1;
	r = z2ipoly_find_irreducible(n);
	a0 = z2ipoly_mod(a0, r);
	a = a0;
	fprintf(stderr, "%llx %llx\n", a0, r);

	for (i = 0; i < pn1; i++) {
		p1 = a;
		a = z2ipolymod_mul(a, a0, r);
		p2 = a;
		diff = p2 - p1;
		if (diff < 0)
			diff += 1 << n;
		printf("%08x %+5d\n", p1, diff);
	}

	return 0;
}
