int group_make_quotient(
	group_t * pG,           // in
	group_t * pH,           // in
	void    * GH_buffer,    // in
	int       max_GH_bytes, // in
	int       verbosity,    // in
	group_t * pGH,          // out
	group_spec_t * pGHspec) // out
{
	cosets_t cosets;

	if (!make_cosets(pG, pH, LEFT_COSETS, &cosets, GH_buffer,
		max_GH_bytes, verbosity))
	{
		fprintf(stderr,
			"group_make_quotient:  failed to make cosets.\n");
		return 0;
	}

	pGHspec->element_size = cosets.elements_per_coset
		* pG->pspec->element_size;
	pGHspec->pvop         = special func here;
	pGHspec->pvequal      = special func here;
	pGHspec->pvless       = special func here;
	pGHspec->pvprint      = special func here;
	pGHspec->pvscan       = special func here;
	pGHspec->naux         = pG->pspec->naux;
	pGHspec->pvauxprint   = pG->pspec->pvauxprint;
	pGHspec->pvauxscan    = pG->pspec->pvauxscan;
	pGHspec->pfill_group  = 0;
	pGHspec->desc         = pG->pspec->desc;

	pGH->pvelements       = GH_buffer;
	pGH->num_elements     = cosets.num_cosets;
	pGH->pvaux            = pGH->pvaux;
	pGH->pspec            = pGHspec;

	return 1;
}

// ----------------------------------------------------------------
Want to be able to pipe output into other commands.
Need scanner to detect when a quotient group is in use, and construct
	one if so.
xxx
{
	// ...

	// ...
}
