#include <stdio.h>
#include <stdlib.h>
#include "z2ipolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {polys ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t a, d;
	int argi;

	if (argc < 2)
		usage(argv[0]);

	for (argi = 1; argi < argc; argi++) {
		if (!z2ipoly_scan(&a, argv[argi]))
			usage(argv[0]);
		d = z2ipoly_deriv(a);
		z2ipoly_print(d);
		printf("\n");
	}

	return 0;
}
