#include <stdio.h>
#include <stdlib.h>
#include "z2ipolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {r} {polys ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t r = 0LL, a = 0LL, b = 0LL;
	int argi;

	if (argc < 3)
		usage(argv[0]);
	if (!z2ipolymod_auxscan(&r, argv[1]))
		usage(argv[0]);

	for (argi = 2; argi < argc; argi++) {
		if (!z2ipoly_scan(&a, argv[argi]))
			usage(argv[0]);
		if (a)
			b = z2ipolymod_recip(a, r);
		else
			b = 0;
		z2ipolymod_print(a, r);
		printf("  ");
		z2ipolymod_print(b, r);
		printf("\n");
	}

	return 0;
}
