#include <stdio.h>
#include <stdlib.h>
#include "z2ipolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {polys ...} {e}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	z2ipoly_t c = 1LL, a = 1LL;
	int power;
	int argi;

	if (argc < 3)
		usage(argv[0]);
	if (sscanf(argv[argc-1], "%d", &power) != 1)
		usage(argv[0]);

	for (argi = 1; argi < argc-1; argi++) {
		if (!z2ipoly_scan(&a, argv[argi]))
			usage(argv[0]);
		c = z2ipoly_power(a, power);
		z2ipoly_print(c);
		printf("\n");
	}

	return 0;
}
