#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {m} {numbers ...}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int argi;
	char * pcaret;
	int m, prod, a, ap, power;

	if (argc < 3)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &m) != 1)
		usage(argv[0]);


	prod = 1;
	for (argi = 2; argi < argc; argi++) {
		pcaret = strchr(argv[argi], '^');
		if (pcaret) {
			*pcaret = 0;
			if (!sscanf(pcaret + 1, "%d", &power)) {
				usage(argv[0]);
			}
		}
		else {
			power = 1;
		}
		if (sscanf(argv[argi], "%d", &a) != 1)
			usage(argv[0]);
		a %= m;
		ap = a;
		if (power != 1)
			ap = mod_power(a, power, m);
		prod *= ap;
		prod %= m;
	}
	printf("%d\n", prod);

	return 0;
}
