#include <stdio.h>
#include <stdlib.h>
#include "zppolymod.h"

// ----------------------------------------------------------------
static void usage(char * argv0)
{
	fprintf(stderr, "Usage: %s {p} {a} {b}\n", argv0);
	exit(1);
}

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	zpoly_t a, b, g;
	int p;

	if (argc != 4)
		usage(argv[0]);
	if (sscanf(argv[1], "%d", &p) != 1)
		usage(argv[0]);
	if (!zppoly_scan(&a, argv[2], p))
		usage(argv[0]);
	if (!zppoly_scan(&b, argv[3], p))
		usage(argv[0]);
	g = zppoly_gcd(&a, &b, p);
	zppoly_print(&g, p);
	printf("\n");

	return 0;
}
