#include <stdio.h>
#include <stdlib.h>
#include "z2ipolymod.h"
#include "z2ilinalg.h"
#include "malloc_check.h"

static void do_matrix(
	z2ipoly_t M[4])
{
	int i;
	z2ipoly_t a = 1LL;

	for (i = 0; i < 16; i++) {
		printf("%llx", a);
		printf("\n");
		a = z2ila_mx_times_vr(M, 4, a);
	}

	printf("\n");
}

// ----------------------------------------------------------------
// Fibo        Gal         Rev. fibo   Rev. Gal = u-RER
// 0 0 1 1     0 0 0 1     0 1 0 0     0 1 0 0
// 1 0 0 0     1 0 0 1     0 0 1 0     0 0 1 0
// 0 1 0 0     0 1 0 0     0 0 0 1     1 0 0 1
// 0 0 1 0     0 0 1 0     1 1 0 0     1 0 0 0

int main(int argc, char ** argv)
{
	z2ipoly_t F [4] = {0x3, 0x8, 0x4, 0x2};
	z2ipoly_t G [4] = {0x1, 0x9, 0x4, 0x2};
	z2ipoly_t Fr[4] = {0x4, 0x2, 0x1, 0xc};
	z2ipoly_t Gr[4] = {0x4, 0x2, 0x9, 0x8};

	do_matrix(F);
	do_matrix(G);
	do_matrix(Fr);
	do_matrix(Gr);

	return 0;
}
