#include <stdio.h>
#include <stdlib.h>
#include "gcd.h"
#include "phi.h"

// ----------------------------------------------------------------
int main(int argc, char ** argv)
{
	int m = 990;
	int x;
	int r9, r10, r11;
	int rex;

	//int m9  = 550;
	//int m10 = 396;
	//int m11 = 540;
	//int a   = 495;

	int m9  = 550;
	int m10 = 891;
	int m11 = 540;
	int a   =   0;

	int ngood = 0;
	int nbad  = 0;

	if (argc == 5) {
		(void)sscanf(argv[1], "%d", &m9);
		(void)sscanf(argv[2], "%d", &m10);
		(void)sscanf(argv[3], "%d", &m11);
		(void)sscanf(argv[4], "%d", &a);
	}

	for (x = 1; x < m; x++) {
		if (calc_gcd(x, m) != 1)
			continue;
		r9  = x % 9;
		r10 = x % 10;
		r11 = x % 11;
		rex = (
			((r9 * m9 ) % m) +
			((r10* m10) % m) +
			((r11* m11) % m) +
			a
		) % m;
		if (x == rex)
			ngood++;
		else
			nbad++;
		printf(
	"%3d: (%3d, %3d, %3d) => %3d*%3d + %3d+%3d * %3d+%3d=> %3d",
			x,
			r9, r10, r11,
			m9,  r9,
			m10, r10,
			m11, r11,
			rex);
		if (x != rex)
			printf(" diff %d", (m + x - rex) % m);
		printf("\n");
	}
	printf("ngood %d nbad %d\n", ngood, nbad);

	return 0;
}
