#ifndef IROOT_H
#define IROOT_H

#include "intfc.h"

// kth root of n.
// want_ceil is either IFLOOR or ICEIL

unsigned calc_iroot_32(
	unsigned n,
	unsigned k,
	int want_ceil);

unsigned long long calc_iroot_64(
	unsigned long long n,
	unsigned long long k,
	int want_ceil);

#endif // IROOT_H
