#ifndef JACSYM_H
#define JACSYM_H

// Given (x|m), with m factoring into product of pi**ai,
// returns product of (x|pi)**ai, with (x|pi) being the
// Legendre symbol of x and pi.

int calc_jacsym_32(
	unsigned x,
	unsigned m);

int calc_jacsym_64(
	unsigned long long x,
	unsigned long long m);

#endif // JACSYM_H
