#include "gcd.h"
#include "phi.h"

static int get_phi(int n)
{
	static int have_last = 0;
	static int last_n;
	static int last_phi;
	int phi;
	int i;

	if (have_last) {
		if (last_n == n) {
			return last_phi;
		}
	}

	phi = 0;
	for (i = 1; i < n; i++) {
		if (calc_gcd(n, i) == 1)
			phi++;
	}

	have_last = 1;
	last_n = n;
	last_phi = phi;
	return phi;
}
